gtkmm: Gtk::FilterListModel Class Reference

gtkmm 4.13.2

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Functions | List of all members
Gtk::FilterListModel Class Reference
ListView Classes

A list model that filters its items. More...

`#include <gtkmm/filterlistmodel.h>`

Inheritance diagram for Gtk::FilterListModel:
[legend]

## Public Member Functions
| FilterListModel (FilterListModel && src) noexcept
FilterListModel & | operator= (FilterListModel && src) noexcept
| ~FilterListModel () noexcept override
GtkFilterListModel * | gobj ()
| Provides access to the underlying C GObject. More...
const GtkFilterListModel * | gobj () const
| Provides access to the underlying C GObject. More...
GtkFilterListModel * | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
void | set_filter (const Glib::RefPtr< Filter > & filter)
| Sets the filter used to filter items. More...
Glib::RefPtr< Filter > | get_filter ()
| Gets the `Gtk::Filter` currently set on self. More...
Glib::RefPtr< const Filter > | get_filter () const
| Gets the `Gtk::Filter` currently set on self. More...
void | set_model (const Glib::RefPtr< Gio::ListModel > & model)
| Sets the model to be filtered. More...
Glib::RefPtr< Gio::ListModel > | get_model ()
| Gets the model currently filtered or `nullptr` if none. More...
Glib::RefPtr< const Gio::ListModel > | get_model () const
| Gets the model currently filtered or `nullptr` if none. More...
void | set_incremental (bool incremental=true)
| Sets the filter model to do an incremental sort. More...
bool | get_incremental () const
| Returns whether incremental filtering is enabled. More...
guint | get_pending () const
| Returns the number of items that have not been filtered yet. More...
Glib::PropertyProxy< Glib::RefPtr< Filter > > | property_filter ()
| The filter for this model. More...
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< Filter > > | property_filter () const
| The filter for this model. More...
Glib::PropertyProxy< bool > | property_incremental ()
| If the model should filter items incrementally. More...
Glib::PropertyProxy_ReadOnly< bool > | property_incremental () const
| If the model should filter items incrementally. More...
Glib::PropertyProxy_ReadOnly< GType > | property_item_type () const
| The type of items. More...
Glib::PropertyProxy< Glib::RefPtr< Gio::ListModel > > | property_model ()
| The model being filtered. More...
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< Gio::ListModel > > | property_model () const
| The model being filtered. More...
Glib::PropertyProxy_ReadOnly< unsigned int > | property_n_items () const
| The number of items. More...
Glib::PropertyProxy_ReadOnly< guint > | property_pending () const
| Number of items not yet filtered. More...
Public Member Functions inherited from Glib::Object
| Object (const Object &)=delete
Object & | operator= (const Object &)=delete
| Object (Object &&src) noexcept
Object & | operator= (Object &&src) noexcept
void * | get_data (const QueryQuark &key)
void | set_data (const Quark &key, void *data)
void | set_data_with_c_callback (const Quark &key, void *data, GDestroyNotify notify)
void | set_data (const Quark &key, void *data, DestroyNotify notify)
void | remove_data (const QueryQuark &quark)
void * | steal_data (const QueryQuark &quark)
Glib::RefPtr< Glib::Object > | wrap (GObject *object, bool take_copy=false)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring &property_name, const Glib::ValueBase &value)
void | get_property_value (const Glib::ustring &property_name, Glib::ValueBase &value) const
void | set_property (const Glib::ustring &property_name, const PropertyType &value)
void | get_property (const Glib::ustring &property_name, PropertyType &value) const
PropertyType | get_property (const Glib::ustring &property_name) const
sigc::connection | connect_property_changed (const Glib::ustring &property_name, const sigc::slot< void()> &slot)
sigc::connection | connect_property_changed (const Glib::ustring &property_name, sigc::slot< void()> &&slot)
void | freeze_notify ()
void | thaw_notify ()
virtual void | reference () const
virtual void | unreference () const
GObject * | gobj ()
const GObject * | gobj () const
GObject * | gobj_copy () const
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src) noexcept
| ~trackable ()
void | add_destroy_notify_callback (notifiable *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src) noexcept
void | remove_destroy_notify_callback (notifiable *data) const
Public Member Functions inherited from Gio::ListModel
| ListModel (ListModel &&src) noexcept
ListModel & | operator= (ListModel &&src) noexcept
| ~ListModel () noexcept override
GListModel * | gobj ()
const GListModel * | gobj () const
GType | get_item_type () const
guint | get_n_items () const
Glib::RefPtr< Glib::ObjectBase > | get_object (guint position)
Glib::RefPtr< const Glib::ObjectBase > | get_object (guint position) const
Glib::RefPtr< T_item > | get_typed_object (guint position)
Glib::RefPtr< const T_item > | get_typed_object (guint position) const
Glib::SignalProxy< void(guint, guint, guint)> | signal_items_changed ()
Glib::RefPtr< Gio::ListModel > | wrap (GListModel *object, bool take_copy=false)
Public Member Functions inherited from Glib::Interface
| Interface ()
| Interface (Interface &&src) noexcept
Interface & | operator= (Interface &&src) noexcept
| Interface (const Glib::Interface_Class &interface_class)
| Interface (GObject *castitem)
| ~Interface () noexcept override
| Interface (const Interface &)=delete
Interface & | operator= (const Interface &)=delete
GObject * | gobj ()
const GObject * | gobj () const

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
static Glib::RefPtr< FilterListModel > | create (const Glib::RefPtr< Gio::ListModel > & model, const Glib::RefPtr< Filter > & filter)
Static Public Member Functions inherited from Gio::ListModel
static void | add_interface (GType gtype_implementer)
static GType | get_type ()

## Protected Member Functions
| FilterListModel (const Glib::RefPtr< Gio::ListModel > & model, const Glib::RefPtr< Filter > & filter)
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams &construct_params)
| Object (GObject *castitem)
| ~Object () noexcept override
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| ObjectBase (const char *custom_type_name)
| ObjectBase (const std::type_info &custom_type_info)
| ObjectBase (ObjectBase &&src) noexcept
ObjectBase & | operator= (ObjectBase &&src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject *castitem)
void | initialize_move (GObject *castitem, Glib::ObjectBase *previous_wrapper)
Protected Member Functions inherited from Gio::ListModel
| ListModel ()
void | items_changed (guint position, guint removed, guint added)
virtual GType | get_item_type_vfunc ()
virtual guint | get_n_items_vfunc ()
virtual gpointer | get_item_vfunc (guint position)

## Related Functions
(Note that these are not member functions.)
Glib::RefPtr< Gtk::FilterListModel > | wrap (GtkFilterListModel * object, bool take_copy=false)
| A Glib::wrap() method for this object. More...

## Additional Inherited Members
Public Types inherited from Glib::Object
typedef void(*)(gpointer data | DestroyNotify)
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify
Public Types inherited from sigc::notifiable
typedef internal::func_destroy_notify | func_destroy_notify

## Detailed Description

A list model that filters its items.

Gtk::FilterListModel is a list model that filters a given other listmodel. It hides some elements from the other model according to criteria given by a Gtk::Filter.

The model can be set up to do incremental searching, so that filtering long lists doesn't block the UI. See set_incremental() for details.

See also
  Gio::ListModel, Gtk::Filter

Since gtkmm 3.98:

## Constructor & Destructor Documentation

## ◆ FilterListModel() [1/2]

Gtk::FilterListModel::FilterListModel | ( | FilterListModel && | src | ) |
| noexcept

## ◆ ~FilterListModel()

Gtk::FilterListModel::~FilterListModel | ( |  | ) |
| overridenoexcept

## ◆ FilterListModel() [2/2]

Gtk::FilterListModel::FilterListModel | ( | const Glib::RefPtr< Gio::ListModel > & | model,
|  | const Glib::RefPtr< Filter > & | filter
| ) |  |
| explicitprotected

## Member Function Documentation

## ◆ create()

static Glib::RefPtr< FilterListModel > Gtk::FilterListModel::create | ( | const Glib::RefPtr< Gio::ListModel > & | model,
|  | const Glib::RefPtr< Filter > & | filter
| ) |  |
| static

## ◆ get_filter() [1/2]

Glib::RefPtr< Filter > Gtk::FilterListModel::get_filter | ( |  | ) |

Gets the `Gtk::Filter` currently set on self.

Returns
  The filter currently in use.

## ◆ get_filter() [2/2]

Glib::RefPtr< const Filter > Gtk::FilterListModel::get_filter | ( |  | ) | const

Gets the `Gtk::Filter` currently set on self.

Returns
  The filter currently in use.

## ◆ get_incremental()

bool Gtk::FilterListModel::get_incremental | ( |  | ) | const

Returns whether incremental filtering is enabled.

See set_incremental().

Returns
  `true` if incremental filtering is enabled.

## ◆ get_model() [1/2]

Glib::RefPtr< Gio::ListModel > Gtk::FilterListModel::get_model | ( |  | ) |

Gets the model currently filtered or `nullptr` if none.

Returns
  The model that gets filtered.

## ◆ get_model() [2/2]

Glib::RefPtr< const Gio::ListModel > Gtk::FilterListModel::get_model | ( |  | ) | const

Gets the model currently filtered or `nullptr` if none.

Returns
  The model that gets filtered.

## ◆ get_pending()

guint Gtk::FilterListModel::get_pending | ( |  | ) | const

Returns the number of items that have not been filtered yet.

You can use this value to check if self is busy filtering by comparing the return value to 0 or you can compute the percentage of the filter remaining by dividing the return value by the total number of items in the underlying model:

[C example ellipted]

If no filter operation is ongoing - in particular when property_incremental() is `false` - this function returns 0.

Returns
  The number of items not yet filtered.

## ◆ get_type()

static GType Gtk::FilterListModel::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ gobj() [1/2]

GtkFilterListModel * Gtk::FilterListModel::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const GtkFilterListModel * Gtk::FilterListModel::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ gobj_copy()

GtkFilterListModel * Gtk::FilterListModel::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

## ◆ operator=()

FilterListModel & Gtk::FilterListModel::operator= | ( | FilterListModel && | src | ) |
| noexcept

## ◆ property_filter() [1/2]

Glib::PropertyProxy< Glib::RefPtr< Filter > > Gtk::FilterListModel::property_filter | ( |  | ) |

The filter for this model.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_filter() [2/2]

Glib::PropertyProxy_ReadOnly< Glib::RefPtr< Filter > > Gtk::FilterListModel::property_filter | ( |  | ) | const

The filter for this model.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_incremental() [1/2]

Glib::PropertyProxy< bool > Gtk::FilterListModel::property_incremental | ( |  | ) |

If the model should filter items incrementally.

Default value: `false`

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_incremental() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gtk::FilterListModel::property_incremental | ( |  | ) | const

If the model should filter items incrementally.

Default value: `false`

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_item_type()

Glib::PropertyProxy_ReadOnly< GType > Gtk::FilterListModel::property_item_type | ( |  | ) | const

The type of items.

See Gio::ListModel::get_item_type().

Since gtkmm 4.8:

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_model() [1/2]

Glib::PropertyProxy< Glib::RefPtr< Gio::ListModel > > Gtk::FilterListModel::property_model | ( |  | ) |

The model being filtered.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_model() [2/2]

Glib::PropertyProxy_ReadOnly< Glib::RefPtr< Gio::ListModel > > Gtk::FilterListModel::property_model | ( |  | ) | const

The model being filtered.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_n_items()

Glib::PropertyProxy_ReadOnly< unsigned int > Gtk::FilterListModel::property_n_items | ( |  | ) | const

The number of items.

See Gio::ListModel::get_n_items().

Since gtkmm 4.8:

Default value: 0

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_pending()

Glib::PropertyProxy_ReadOnly< guint > Gtk::FilterListModel::property_pending | ( |  | ) | const

Number of items not yet filtered.

Default value: 0

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ set_filter()

void Gtk::FilterListModel::set_filter | ( | const Glib::RefPtr< Filter > & | filter | ) |

Sets the filter used to filter items.

Parameters

  filter | Filter to use.

## ◆ set_incremental()

void Gtk::FilterListModel::set_incremental | ( | bool | incremental = `true` | ) |

Sets the filter model to do an incremental sort.

When incremental filtering is enabled, the `Gtk::FilterListModel` will not run filters immediately, but will instead queue an idle handler that incrementally filters the items and adds them to the list. This of course means that items are not instantly added to the list, but only appear incrementally.

When your filter blocks the UI while filtering, you might consider turning this on. Depending on your model and filters, this may become interesting around 10,000 to 100,000 items.

By default, incremental filtering is disabled.

See get_pending() for progress information about an ongoing incremental filtering operation.

Parameters

  incremental | `true` to enable incremental filtering.

## ◆ set_model()

void Gtk::FilterListModel::set_model | ( | const Glib::RefPtr< Gio::ListModel > & | model | ) |

Sets the model to be filtered.

Note that GTK makes no effort to ensure that model conforms to the item type of self. It assumes that the caller knows what they are doing and have set up an appropriate filter to ensure that item types match.

Parameters

  model | The model to be filtered.

## Friends And Related Function Documentation

## ◆ wrap()

Glib::RefPtr< Gtk::FilterListModel > wrap | ( | GtkFilterListModel * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.